!  WATCOM BASIC DEMO PROGRAM
!
!   This program reads the a year from the terminal
!   and generates a calendar for that year.
!
!
option base 1
data 31,28,31,30,31,30,31,31,30,31,30,31
dim DaysInMonth%(12)
mat read DaysInMonth%
dim Calendar%(12,6,7)
loop 
  print "Please enter output file."
  print "i.e. 'printer' for the printer, 'terminal' for the screen,";
  print " 'quit' to stop."
  input out$
  if out$ = 'quit' then quit 
  open #3, out$, output
  input "Please enter year for calendar: ", new_year%
  print #3, chr$(12)
  print #3, tab(25);'Calendar For The Year'; new_year%
  !
  ! Figure out if this is a leap year or not
  !
  DaysInMonth%(2) = 28
  guess 
    if mod( new_year%, 4 ) = 0 then quit 
  admit 
    if mod( new_year%, 100 ) <> 0 then quit 
    if mod( new_year%, 400 ) =  0 then quit 
  admit 
    DaysInMonth%(2) = 29
  endguess 
  call CalcCalendar( new_year% )
  call PrintCalendar
  close #3
endloop 
stop 

proc CalcCalendar( year% ), cent%, decade%, month%, week%, day%
  !
  !  The following formula calculates which day of the week corresponds
  !  to January 1 of the given year
  !
  cent%=int(year%/100)
  decade%=year%-cent%*100-1
  four% = 4 ! this is to get integer division in the following expression
  day_of_week%=mod(29+decade%+decade%/four%+cent%/four%-cent%*2,7)+1
  !
  !   Initialize the entire calendar array to zeros
  !
  mat Calendar% = ( 0 )
  !
  !   Fill in the calendar array
  !
  for month% = 1 to 12
      week% = 1
      for day% = 1 to DaysInMonth%( month% )
        Calendar%( month%, week%, day_of_week% ) = day%
        day_of_week% = day_of_week% + 1
        if day_of_week% > 7
          day_of_week% = 1
          week% = week% + 1
        endif 
      next day%
  next month%
endproc 

proc PrintCalendar
  days$ = "  S  M  T  W  T  F  S"
  call PrintRow(  1, 'Jan', 'Feb', 'Mar' )
  call PrintRow(  4, 'Apr', 'May', 'Jun' )
  call PrintRow(  7, 'Jul', 'Aug', 'Sep' )
  call PrintRow( 10, 'Oct', 'Nov', 'Dec' )
endproc 

proc PrintRow( start_month%, month1$, month2$, month3$ )
  print #3
  print #3, tab(10);month1$;space$(25);month2$;space$(25);month3$
  print #3, days$; space$(6); days$; space$(6); days$
  for week% = 1 to 6
    spacing$ = ''
    for month% = start_month% to start_month% + 2
      print #3, spacing$;
      for day_of_week% = 1 to 7
        print #3, using '@ZZZ@', Calendar%( month%, week%, day_of_week% );
      next day_of_week%
      spacing$ = space$( 6 )
    next month%
    print #3
  next week%
endproc 
